

int iconX;
int iconY;
int tempX;
int tempY;
int timeX;
int timeY;
int dayX;
int dayY;
int dateX;
int dateY;
int battX;
int battY;
int wifiX;
int wifiY;

char currWeatherIcon[20];
char currTemp[4] = "   ";

char timeVal[6] = "     ";
char dayVal[4] = "   ";
char dateVal[3] = "  ";
char battVal[5] = "    ";
char wifiVal[5] = "IDLE";

void updateMenuData(int x, int y, char *oldDataString, char *newDataString, uint16_t fontColor, uint16_t backgroundColor, char *font) {

  tft.loadFont(font);

  //clear;
  tft.setTextColor(backgroundColor, backgroundColor);
  tft.drawRightString(oldDataString, x, y, 8);

  //update
  tft.setTextColor(fontColor, backgroundColor);
  tft.drawRightString(newDataString, x, y, 8);

}

void stComm(){
   char *menuArr[] = {"WELCOME"};
    lcarsBackground(st_BLUE, menuArr, 0 , 0);

    fex.drawBmp("/stcomm.bmp", 20, 30);
    tft.setTextColor(st_WHITE, st_BLACK);
    tft.loadFont(STFONT28);
    tft.setCursor(32, 280);
    tft.println("ESTABLISHING CONNECTION...");
}

void displayWelcome() {

  if (homeInt > 2) {
    homeInt = 0;
  }
  allButtonsOff();
  if (homeInt == 0) {
    allButtonsOff();

    char *menuArr[] = {SPLASH};
    lcarsBackground(st_BLUE, menuArr, 0 , 0);

    fex.drawBmp("/ufp.bmp", 20, 30);
    tft.setTextColor(st_WHITE, st_BLACK);
    tft.loadFont(STFONT28);
    tft.setCursor(32, 250);
    tft.println("UNITED FEDERATION OF PLANETS");

  } else if (homeInt == 1) {

    char *schematicArr[] = {"SCHEMATIC"};
    lcarsBackground(st_BLUE, schematicArr, 0 , 0);

    fex.drawBmp("/schem.bmp", 5, 90);

    tft.loadFont(STFONT38);
    tft.setTextDatum(TR_DATUM);
    tft.setTextColor(st_WHITE, st_BLACK);
    tft.drawString(STARSHIP, 280 , 30, 8);
    tft.loadFont(STFONT28);
    tft.drawString(REGISTRY, 280 , 60, 8);


    tft.loadFont(STFONT28);
    tft.setTextColor(st_LTGRAY, st_BLACK);
    tft.setTextDatum(TL_DATUM);
    tft.drawString(CLASS, 10 , 290, 8);

    tft.setTextColor(st_LTGRAY, st_BLACK);
    tft.setTextDatum(TR_DATUM);
    tft.drawString(PREFIX, 280 , 290, 8);

  }
  else if (homeInt == 2) { //Menu

    menuDisplay = true;

    char *schematicArr[] = {"MENU"};
    lcarsBackground(st_BLUE, schematicArr, 0 , 0);

    int y = 35;
    tft.loadFont(STFONT18);
    tft.setTextDatum(TL_DATUM);
    tft.setTextColor(st_LTGRAY, st_BLACK);
    tft.drawString("BUTTON 2:", 10 , y, 8);
    tft.setTextColor(st_WHITE, st_BLACK);
    tft.loadFont(STFONT24);
    tft.drawString("KEYPAD CLICKS: ", 10 , y + 20, 8);

    if (beepActive) {
      tft.setTextColor(st_GREEN, st_BLACK);
      tft.drawString("ON", 260 , y + 20, 8);
    } else {
      tft.setTextColor(st_RED, st_BLACK);
      tft.drawString("OFF", 260 , y + 20, 8);
    }

    y += 50;
    tft.loadFont(STFONT18);
    tft.setTextDatum(TL_DATUM);
    tft.setTextColor(st_LTGRAY, st_BLACK);
    tft.drawString("BUTTON 3:", 10 , y, 8);
    tft.setTextColor(st_WHITE, st_BLACK);
    tft.loadFont(STFONT24);
    tft.drawString("ALARM: ", 10 , y + 20, 8);

    if (alarmActive) {
      tft.setTextColor(st_GREEN, st_BLACK);
      tft.drawString("ON", 260 , y + 20, 8);
    } else {
      tft.setTextColor(st_RED, st_BLACK);
      tft.drawString("OFF", 260 , y + 20, 8);
    }

    y += 50;
    tft.loadFont(STFONT18);
    tft.setTextDatum(TL_DATUM);
    tft.setTextColor(st_LTGRAY, st_BLACK);
    tft.drawString("BUTTON 4:", 10 , y, 8);
    tft.setTextColor(st_WHITE, st_BLACK);
    tft.loadFont(STFONT24);
    tft.drawString("RESET CALENDAR AUTHENTICATION ", 10 , y + 20, 8);

    y += 50;
    tft.loadFont(STFONT18);
    tft.setTextDatum(TL_DATUM);
    tft.setTextColor(st_LTGRAY, st_BLACK);
    tft.drawString("BUTTON 5:", 10 , y, 8);
    tft.setTextColor(st_WHITE, st_BLACK);
    tft.loadFont(STFONT24);
    tft.drawString("RESET FITNESS AUTHENTICATION ", 10 , y + 20, 8);

        y += 50;
    tft.loadFont(STFONT18);
    tft.setTextDatum(TL_DATUM);
    tft.setTextColor(st_LTGRAY, st_BLACK);
    tft.drawString("BUTTON 6:", 10 , y, 8);
    tft.setTextColor(st_WHITE, st_BLACK);
    tft.loadFont(STFONT24);
    tft.drawString("RESET DEVICE ", 10 , y + 20, 8);


    tft.loadFont(STFONT18);
    tft.setTextDatum(TR_DATUM);
    tft.setTextColor(st_LTGRAY, st_BLACK);
    tft.drawString("BUTTON 1 (MENU BUTTON) TO EXIT", 300 , 290, 8);

    tft.setTextDatum(TL_DATUM);


  }
  homeInt++;

}

void displayDeviceCode(const char *url, const char *code) {

  allButtonsOff();

  char *menuArr[] = {"AUTHENTICATION REQUIRED"};
  lcarsBackground(st_PEACH, menuArr, 0 , 0);

  /*  fex.drawBmp("/ufp.bmp", 20, 30);
    tft.setTextColor(st_WHITE, st_BLACK);
    tft.loadFont(STFONT28);
    tft.setCursor(32, 250);
    tft.println("UNITED FEDERATION OF PLANETS");*/

  int x = 20;
  int y = 50;
  int yTab = 30;

  tft.loadFont(STFONT28);
  tft.setTextColor(st_LTGRAY, st_BLACK);
  tft.setTextDatum(TL_DATUM);
  tft.drawString("VISIT THE FOLLOWING WEBSITE:", x, y, 4);
  y += yTab;
  tft.loadFont(STFONT28);
  tft.setTextColor(st_WHITE, st_BLACK);
  tft.drawString(url, x, y, 4);
  y += yTab * 2;
  tft.loadFont(STFONT28);
  tft.setTextColor(st_LTGRAY, st_BLACK);
  tft.drawString("AND ENTER THE FOLLOWING CODE:", x, y, 4);
  y += yTab;
  tft.loadFont(STFONT28);
  tft.setTextColor(st_WHITE, st_BLACK);
  tft.drawString(code, x, y, 4);

}


void displayDeviceAuth(const char *message) {

  allButtonsOff();

  char *menuArr[] = {"AUTHENTICATION STATUS"};
  lcarsBackground(st_PEACH, menuArr, 0 , 0);

  /*  fex.drawBmp("/ufp.bmp", 20, 30);
    tft.setTextColor(st_WHITE, st_BLACK);
    tft.loadFont(STFONT28);
    tft.setCursor(32, 250);
    tft.println("UNITED FEDERATION OF PLANETS");*/

  int x = 20;
  int y = 50;
  int yTab = 30;

  tft.loadFont(STFONT28);
  tft.setTextColor(st_WHITE, st_BLACK);
  tft.setTextDatum(TL_DATUM);
  tft.drawString(message, x, y, 4);


}


tsButton tsWeather;

int aniWeatherChartX;
int aniWeatherChartY;
int anyWeatherThickness;
int aniWeatherYadj = 0;
int aniWeatherYinc = 1;
uint16_t weatherColor = st_HTPINK;

void weatherChartAnimation() {

  //aniWeatherYadj
  int xAdj = 1;
  int yAdj = 10;
  int w = 2;
  int h = 4;
  int yTravelMin = aniWeatherChartY + yAdj;
  int yTravelMax = 50 + aniWeatherChartY;

  int x = aniWeatherChartX + xAdj;
  int y = aniWeatherChartY + yAdj + aniWeatherYadj;
  int wOpp = aniWeatherChartX + xAdj + 97;
  tft.fillRect(x, y, w, h, weatherColor);
  //tft.fillRect(wOpp, y, w, h, st_BLUE);

  if ((y > yTravelMax) && (aniWeatherYinc > 0)) {
    //downDir = false;
    aniWeatherYinc = -1;
  }

  if ((y <= yTravelMin) && (aniWeatherYinc < 0)) {
    aniWeatherYinc = 1;
  }

  aniWeatherYadj += aniWeatherYinc;
  tft.fillRect(aniWeatherChartX + xAdj, aniWeatherChartY + yAdj + aniWeatherYadj, w, h, st_WHITE);


  if (aniWeatherYinc > 0) {
    y = map (y, yTravelMin, yTravelMax, yTravelMax, yTravelMin);
    tft.fillRect(wOpp, y, w, h, st_BLUE);
  } else {
    tft.fillRect(wOpp, y - 1, w, h + 1, st_BLACK);
  }

}


void lcarsStaticMenu() {


  int margins = 5;
  int iconDim = 50;
  int lineThickness = 4;
  int radius = 5;
  int chartWidth = 95;
  int chartHeight = 55;

  int spaceOverFromMenu = 30;

  int menuStart = (tftWidth - staticMenuWidth) * percContentMenuWidth + spaceOverFromMenu;

  int chartStartX = 370 + margins;
  int chartStartY = margins * 2;
  int outerRingW = chartWidth + margins * 2;
  int innerRingW = outerRingW - lineThickness * 2;
  int outerRingH = chartHeight + margins * 2;
  int innerRingH = outerRingH - lineThickness * 2;
  int blackoutStart = chartStartX + margins;

  aniWeatherChartX = chartStartX;
  aniWeatherChartY = chartStartY;
  anyWeatherThickness = lineThickness;

  tsWeather.x  = chartStartX;
  tsWeather.y  = chartStartY;
  tsWeather.w  = outerRingW;
  tsWeather.h  = innerRingW;

  iconX = chartStartX + margins;
  iconY = chartStartY + margins;

  //create box outer ring
  tft.fillRoundRect(chartStartX , chartStartY, outerRingW, outerRingH, radius, weatherColor);

  //create inner ring
  tft.fillRoundRect(chartStartX + lineThickness, chartStartY + lineThickness, innerRingW, innerRingH , radius, st_BLACK);

  //create blackout to finish chart
  tft.fillRect(blackoutStart + margins, chartStartY , outerRingW - margins * 4, chartHeight * 1.3 , st_BLACK);

  //img.draw(tft, iconStartX, iconStartY);
  //fex.drawBmp("/clear.bmp", iconX, iconY);

  tempX = iconX + iconDim * 1.65;
  tempY = iconY + iconDim * .2;


  int space = 5;
  int boxStartX = menuStart;
  int boxStartY = iconY + outerRingH + space * 2;
  int boxWidth = 40;

  int textHeaderStart = 390;
  int textHeaderLength = 25;

  int textStartX = 440;
  int textStartY = 110;
  int textSpace = 32;

  int lines = 1;

  tft.setTextColor(st_BLACK, st_LTPURPLE);
  tft.loadFont(STFONT18);
  tft.fillRect(boxStartX, boxStartY - margins / 2 , boxWidth, lines * textSpace , st_LTPURPLE);
  tft.setCursor(textHeaderStart, boxStartY - margins * 2 + textHeaderLength * lines); //need to better calculate location later
  tft.println("TIME");



  timeX = tftWidth - margins;
  timeY = boxStartY;
  updateMenuData(timeX, timeY, timeVal, timeVal, st_WHITE, st_BLACK, STFONT38);
  //    tft.setTextColor(st_WHITE, st_BLACK);
  //  tft.loadFont(STFONT40);
  //  tft.drawRightString("----", timeX, timeY, 8);



  //writedate

  boxStartY += textSpace + space;
  lines = 2;

  tft.fillRect(boxStartX, boxStartY - margins / 2 , boxWidth, lines * textSpace , st_TAN);
  tft.setTextColor(st_BLACK, st_TAN);
  tft.loadFont(STFONT18);
  tft.setCursor(textHeaderStart, boxStartY - margins + lines * textHeaderLength); //need to better calculate location later
  tft.println("DATE");

  dayX = tftWidth - margins;
  dayY = boxStartY;
  updateMenuData(dayX, dayY, dayVal, dayVal, st_TAN, st_BLACK, STFONT38);
  //tft.setTextColor(st_TAN, st_BLACK);
  //tft.loadFont(STFONT40);
  //tft.drawRightString("WED", tftWidth - margins, boxStartY, 8);


  boxStartY += textSpace;
  dateX = tftWidth - margins;
  dateY = boxStartY;
  updateMenuData(dateX, dateY, dateVal, dateVal, st_TAN, st_BLACK, STFONT38);
  //tft.drawRightString("2", tftWidth - margins, boxStartY, 8);

  //write power

  boxStartY += textSpace + space;
  lines = 1;

  tft.fillRect(boxStartX, boxStartY - margins / 2 , boxWidth, lines * textSpace , st_ORANGE);
  tft.setTextColor(st_BLACK, st_ORANGE);
  tft.loadFont(STFONT18);
  tft.setCursor(textHeaderStart, boxStartY - margins * 2 + lines * textHeaderLength ); //need to better calculate location later
  tft.println("BATT");

  battX = tftWidth - margins;
  battY = boxStartY;
  updateMenuData(battX, battY, battVal, battVal, st_ORANGE, st_BLACK, STFONT38);

  // write wifi

  boxStartY += textSpace + space;
  lines = 1;

  tft.fillRect(boxStartX, boxStartY - margins / 2 , boxWidth, lines * textSpace , st_PURPLE);
  tft.setTextColor(st_BLACK, st_PURPLE);
  tft.loadFont(STFONT18);
  tft.setCursor(textHeaderStart, boxStartY - margins * 2 + lines * textHeaderLength ); //need to better calculate location later
  tft.println("WIFI");


  wifiX = tftWidth - margins;
  wifiY = boxStartY;
  updateMenuData(wifiX, wifiY, wifiVal, wifiVal, st_PURPLE, st_BLACK, STFONT38);


  //menu button

  Serial.println(boxStartX);
  Serial.println(boxStartY);



  /* boxStartY += textSpace + space;
    float buttonLines = 1.55;

    tft.fillRoundRect(boxStartX, boxStartY , boxWidth + 65, buttonLines * textSpace , (buttonLines * textSpace) / 2, st_LTGRAY);
    tft.fillRect(boxStartX, boxStartY , boxWidth, buttonLines * textSpace , st_LTGRAY);
    tft.setTextColor(st_BLACK, st_LTGRAY);
    tft.loadFont(STFONT18);
    tft.setCursor(textHeaderStart + 48, boxStartY - margins * 2 + buttonLines * textHeaderLength ); //need to better calculate location later
    tft.println("MENU");*/

  drawAlarm();
  drawKeypadVol();

}

void drawAlarm() {

  char alarmText[10];
  uint16_t fontColor;

  int x = 374;
  int y = 270;
  int w = 120;
  int h = 20;
  int r = 8;

  int xFont = 470;
  int yFont = 272;

  if (alarmActive) {
    strcpy(alarmText, "ALARM ON");
    fontColor = st_GREEN;
  } else {
    strcpy(alarmText, "ALARM OFF");
    fontColor = st_RED;
  }
  tft.loadFont(STFONT18);
  tft.setTextColor(st_BLACK, fontColor);
  tft.fillRoundRect(x, y, w, h, r, fontColor);
  tft.setTextDatum(TR_DATUM);
  tft.drawString(alarmText, xFont, yFont, 4);

  tft.setTextDatum(TL_DATUM);
}

void drawKeypadVol() {

  char volText[10];
  uint16_t fontColor;

  int x = 374;
  int y = 295;
  int w = 120;
  int h = 20;
  int r = 8;

  int xFont = 470;
  int yFont = 297;

  if (beepActive) {
    strcpy(volText, "BEEP ON");
    fontColor = st_GREEN;
  } else {
    strcpy(volText, "BEEP OFF");
    fontColor = st_RED;
  }
  tft.loadFont(STFONT18);
  tft.setTextColor(st_BLACK, fontColor);
  tft.fillRoundRect(x, y, w, h, r, fontColor);
  tft.setTextDatum(TR_DATUM);
  tft.drawString(volText, xFont, yFont, 4);

  tft.setTextDatum(TL_DATUM);

}

void lcarsBackground(uint16_t backgroundColor, char *menuArr[], int menuItemNo, int itemHL) {

  tft.setTextColor(backgroundColor, st_BLACK);
  tft.loadFont(STFONT28);

  int titleLength = tft.textWidth(menuArr[0]);

  int margins = 1;
  int outerRadius = 40;
  int innerRadius = 20;
  int truefontHeight = 28; //in pixels
  int fontHeight = truefontHeight - 8;
  int contentWidth = 410;
  int borderWidthfromStart = tftWidth - staticMenuWidth;
  int contentWidthfromStart = borderWidthfromStart * percContentMenuWidth;
  int headerStart = 10;
  int fontMargin = 5;
  int headerWidth = titleLength + fontMargin;

  //Create outer menu area
  tft.fillRoundRect(outerRadius * -1, margins, borderWidthfromStart, tftHeight + outerRadius, outerRadius, backgroundColor);

  //create area for content
  //fillRoundRect(uint16_t x0, uint16_t y0, uint16_t w, uint16_t h, uint16_t radius, uint16_t color);
  tft.fillRoundRect(outerRadius * -1, fontHeight + margins, contentWidthfromStart, tftHeight + outerRadius, innerRadius, st_BLACK);


  //create black background for rounded end
  tft.fillRect(0, margins, headerWidth / 2, fontHeight, st_BLACK);

  //create rounded end.h
  tft.fillRoundRect(margins, margins, headerWidth / 2, fontHeight, fontHeight * 0.5, backgroundColor);

  //create black background for header
  tft.fillRect(headerStart, margins, headerWidth + fontMargin, fontHeight, st_BLACK);


  //write header title

  tft.setCursor(headerStart + fontMargin, margins);
  //tft.println(title);
  tft.println(menuArr[0]);

  if (menuItemNo > 2) {

    int dividerX = contentWidthfromStart - outerRadius;
    int dividerY = fontHeight * 2.5;
    int dividerGap = 5;
    int menuWidth = borderWidthfromStart - contentWidthfromStart;
    int fontGap = 15;
    int textX = dividerX + dividerGap;

    //initial line
    tft.setTextColor(st_BLACK, backgroundColor);
    tft.loadFont(STFONT18);
    tft.setCursor(dividerX, dividerY);
    tft.println(menuArr[1]);

    int arrayItems = menuItemNo - 2;

    dividerY += fontGap;

    //black rect
    tft.fillRect(dividerX, dividerY, menuWidth, fontHeight * arrayItems + dividerGap, st_BLACK);
    tft.fillRect(dividerX, dividerY + dividerGap, dividerGap, fontHeight * arrayItems - dividerGap, backgroundColor);

    dividerX += dividerGap * 2;

    tft.setTextColor(backgroundColor, st_BLACK);
    for (int i = 2; i < menuItemNo; i++) {
      dividerY += dividerGap;


      tft.setCursor(dividerX, dividerY);
      if (itemHL == i + 1) {
        tft.setTextColor(st_WHITE, st_BLACK);
      } else {
        tft.setTextColor(backgroundColor, st_BLACK);
      }
      //tft.drawRightString(menuArr[i], dividerX + menuWidth - dividerGap, dividerY, 8);
      tft.println(menuArr[i]);
      dividerY += fontGap;
    }

  }

}
