

void displayCurrentWeather(const char* icon, int temp) {

 // tickerHourlyWeather.detach();
 // tickerDailyWeather.detach();
 // tickerHourlyWeather.attach(600, requestHourlyWeather); //getWeather every 10 mins;
 // tickerDailyWeather.attach(3600, requestDailyWeather); //getWeather every hour;

 Serial.println("displayed Current Weather in corner");

  strcpy(currWeatherIcon, "/");
  strcat(currWeatherIcon, icon);
  strcat(currWeatherIcon, ".bmp");

  tft.drawRect(tempX - 50, tempY, 50 , 50, st_BLACK);
  fex.drawBmp(currWeatherIcon, iconX, iconY);
  //   tft.setTextColor(st_DKGRAY, st_BLACK);
  // tft.loadFont(STFONT40);
  // tft.setCursor(tempX, tempY); //need to better calculate location later
  // tft.println(100);

  char buf[4];
  itoa(temp, buf, 10);

  updateMenuData(tempX, tempY, currTemp, buf, st_DKGRAY, st_BLACK, STFONT40);
  strcpy(currTemp, buf);

  tft.drawCircle(tempX + 4, tempY + 3, 2, st_DKGRAY);

}

void displayWeather() {
  allButtonsOff();

  int y = 40;
  int iconsize = 40;
  int x = 15;
  int xTab = iconsize + 15;
  int yTab = 10;

  tft.setTextColor(st_WHITE, st_BLACK);
  tft.loadFont(STFONT24);
  tft.setCursor(x, y);
  tft.println(dailyWeatherName[0]);
  tft.setCursor(260, y);
  tft.println(dailyWeatherTemp[0]);
  tft.drawCircle(275 + 4, y + 1, 2, st_WHITE);
  //hourly values
  y += 40;
  int startY = y;
  int startX = x;
  tft.drawLine(x - 5, y - 10, 280, y - 10, st_PURPLE);

  for (int i = 0; i < 5; i++) {
    y = startY;

    char iconC[20];
    strcpy(iconC, "/");
    strcat(iconC, hourlyWeatherIcon[i]);
    strcat(iconC, "s.bmp");

    char tempC[4];
    itoa(hourlyWeatherTemp[i], tempC, 10);

    char precipC[5];
    itoa(hourlyWeatherPrecip[i], precipC, 10);
    strcat(precipC, "%");


    int centerX = x + iconsize / 2;
    int centerY = y;

    tft.setTextColor(st_WHITE, st_BLACK);
    tft.loadFont(STFONT24);
    tft.drawCentreString(hourlyWeatherHr[i], centerX, centerY, 4);

    if (hourlyWeatherPrecip[i] > 0) {
      tft.setTextColor(st_NTBLUE, st_BLACK);
      tft.loadFont(STFONT18);
      tft.drawCentreString(precipC, centerX, centerY + 23, 4);
    }


    y += 36;

    fex.drawBmp(iconC, x, y);
    y += iconsize;

    tft.setTextColor(st_WHITE, st_BLACK);
    tft.loadFont(STFONT24);
    tft.drawCentreString(tempC, x + iconsize / 2, y, 4);
    tft.drawCircle(x + iconsize * .7 + 4, y + 1, 2, st_WHITE);
    x += xTab;

  }
  tft.drawLine(startX - 5, y + 25, 280, y + 25, st_PURPLE);

  tft.setTextColor(st_WHITE, st_BLACK);
  tft.loadFont(STFONT24);

  y += 40;
  for (int i = 1; i < 4; i++) {

    char iconC[20];
    strcpy(iconC, "/");
    strcat(iconC, dailyWeatherIcon[i]);
    strcat(iconC, "s.bmp");

    x = startX;
    tft.setCursor(x, y);
    tft.println(dailyWeatherName[i]);

    fex.drawBmp(iconC, 180, y - 10);

    tft.setCursor(260, y);
    tft.println(dailyWeatherTemp[i]);
    tft.drawCircle(275 + 4, y + 1, 2, st_WHITE);
    y += 40;

  }




  //Serial.print(hourlyWeatherIconChar);

}
